/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.135
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.54 2009/12/06 09:34:36 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.135 2012/09/06 08:30:00 kensington Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16
17IUSE="${IUSE} debug pch"
18RDEPEND="
19 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999
25 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV}
36 !>x11-libs/qt-script-${PV}-r9999
37 !<x11-libs/qt-sql-${PV}
38 !>x11-libs/qt-sql-${PV}-r9999
39 !<x11-libs/qt-svg-${PV}
40 !>x11-libs/qt-svg-${PV}-r9999
41 !<x11-libs/qt-test-${PV}
42 !>x11-libs/qt-test-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47"
48case "${PV}" in 12case ${EAPI} in
49 4.?.?_rc* | 4.?.?_beta* ) 13 2|3|4) : ;;
50 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
51 MY_PV="${PV/_/-}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
52 ;; 37 ;;
53 *) 38 release)
54 SRCTYPE="${SRCTYPE:-opensource-src}" 39 if version_is_at_least 4.8.1; then
55 MY_PV="${PV}" 40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
56 ;; 44 ;;
57esac 45esac
58 46
47IUSE="aqua debug pch"
48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
59if version_is_at_least 4.5.99999999 ${PV} ; then 49if version_is_at_least 4.8; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
61else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi 52fi
53
54DEPEND="virtual/pkgconfig"
55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
57fi
58
59RDEPEND="
60 !<x11-libs/qt-assistant-${PV}:4
61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
64 !<x11-libs/qt-core-${PV}:4
65 !>x11-libs/qt-core-${PV}-r9999:4
66 !<x11-libs/qt-dbus-${PV}:4
67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
70 !<x11-libs/qt-demo-${PV}:4
71 !>x11-libs/qt-demo-${PV}-r9999:4
72 !<x11-libs/qt-gui-${PV}:4
73 !>x11-libs/qt-gui-${PV}-r9999:4
74 !<x11-libs/qt-multimedia-${PV}:4
75 !>x11-libs/qt-multimedia-${PV}-r9999:4
76 !<x11-libs/qt-opengl-${PV}:4
77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
80 !<x11-libs/qt-phonon-${PV}:4
81 !>x11-libs/qt-phonon-${PV}-r9999:4
82 !<x11-libs/qt-qt3support-${PV}:4
83 !>x11-libs/qt-qt3support-${PV}-r9999:4
84 !<x11-libs/qt-script-${PV}:4
85 !>x11-libs/qt-script-${PV}-r9999:4
86 !<x11-libs/qt-sql-${PV}:4
87 !>x11-libs/qt-sql-${PV}-r9999:4
88 !<x11-libs/qt-svg-${PV}:4
89 !>x11-libs/qt-svg-${PV}-r9999:4
90 !<x11-libs/qt-test-${PV}:4
91 !>x11-libs/qt-test-${PV}-r9999:4
92 !<x11-libs/qt-webkit-${PV}:4
93 !>x11-libs/qt-webkit-${PV}-r9999:4
94 !<x11-libs/qt-xmlpatterns-${PV}:4
95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
96"
97
64S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
65 99
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 101# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then
88 # Make sure debug setting corresponds with qt-core (bug 258512)
89 if [[ $PN != "qt-core" ]]; then
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
91 ~x11-libs/qt-core-${PV} debug"
92 fi
93 105
94 # Check USE requirements 106 # Protect users by not allowing downgrades between releases.
95 qt4-build_check_use 107 # Downgrading revisions within the same release should be allowed.
108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
110 eerror " *** Sanity check to keep you from breaking your system ***"
111 eerror "Downgrading Qt is completely unsupported and will break your system!"
112 die "aborting to save your system"
113 else
114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
96 fi 115 fi
116 fi
97 117
98 PATH="${S}/bin:${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
119 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
100 121 else
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 122 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 123 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
103 echo 124 # platform detection. Note: needs to come before any directories to
104 ebeep 3 125 # avoid extract failure.
126 [[ ${CHOST} == *-apple-darwin* ]] && \
127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
128 ${QT4_EXTRACT_DIRECTORIES}"
105 fi 129 fi
106
107 if [[ "${P}" == "qt-core-4.6.0_rc1" ]]; then
108 ewarn
109 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
110 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
111 ewarn "re-emerge everything that depends on Qt."
112 ewarn "Use the following command:"
113 ewarn
114 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
115 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
116 ewarn " sed \"s/^/=/\"; done)"
117 ewarn
118 ewarn "YOU'VE BEEN WARNED"
119 ewarn
120 ebeep 3
121 fi
122
123} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
124 137
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
126# @DESCRIPTION: 140# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt
133# tarball
134 143
135# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 145# @DESCRIPTION:
137# Unpacks the sources 146# Unpacks the sources.
138qt4-build_src_unpack() { 147qt4-build_src_unpack() {
139 setqtenv 148 setqtenv
140 local target targets licenses tar_pkg tar_args 149
141 if version_is_at_least 4.5 ${PV} ; then 150 if ! version_is_at_least 4.1 $(gcc-version); then
142 licenses="LICENSE.GPL3 LICENSE.LGPL" 151 ewarn "Using a GCC version lower than 4.1 is not supported."
143 else 152 fi
144 licenses="LICENSE.GPL2 LICENSE.GPL3" 153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
145 fi 163 fi
146 for target in configure ${licenses} projects.pro \ 164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
147 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
148 ${QT4_EXTRACT_DIRECTORIES}; do 175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
149 targets="${targets} ${MY_P}/${target}" 177 targets+="${MY_P}/${target} "
150 done 178 done
151 179
152 tar_pkg=${MY_P}.tar.bz2 180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
153 tar_args="xjpf" 181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
154 if version_is_at_least 4.5.3 ${PV} ; then 182 eend $? || die "failed to unpack"
155 tar_pkg=${tar_pkg/bz2/gz}
156 tar_args="xzpf"
157 fi
158
159 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
160 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
161
162 case "${PV}" in
163 4.4.?)
164 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
165 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
166 ;; 183 ;;
167 esac 184 esac
168
169 # Be backwards compatible for now
170 if [[ $EAPI != 2 ]]; then
171 qt4-build_src_prepare
172 fi
173} 185}
174 186
175# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
176# @DESCRIPTION: 189# @DESCRIPTION:
177# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
178# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
179# example: 192# Make sure to specify the full path. This variable is utilised in
180# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
181# ${FILESDIR}"/mypatch2.patch"
182# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
183 199
184# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
185# @DESCRIPTION: 201# @DESCRIPTION:
186# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
187# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
188qt4-build_src_prepare() { 204qt4-build_src_prepare() {
189 setqtenv 205 setqtenv
190 cd "${S}" 206
207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
211 if version_is_at_least 4.7; then
212 # avoid X11 dependency in non-gui packages
213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
215 fi
216
217 if use aqua; then
218 # provide a proper macx-g++-64
219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
220
221 sed -e '/^CONFIG/s:app_bundle::' \
222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
224 fi
191 225
192 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
193 skip_qmake_build_patch 227 skip_qmake_build
194 skip_project_generation_patch 228 skip_project_generation
195 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
196 fi 230 fi
197 231
198 # Bug 282984 && Bug 295530 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
199 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \ 233 # qmake bus errors with -O2 or -O3 but -O1 works
200 -i configure || die "sed qmake compilers failed" 234 # Bug 373061
201 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \ 235 replace-flags -O[23] -O1
202 -i config.tests/unix/compile.test || die "sed test compilers failed" 236 fi
203 237
204 # Bug 178652 238 # Bug 178652
205 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207 append-flags -fno-gcse 241 append-flags -fno-gcse
208 fi 242 fi
209 243
244 if use_if_iuse c++0x; then
245 append-cxxflags -std=c++0x
246 fi
247
210 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
211 if [[ $(gcc-major-version) -lt "4" ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
212 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
213 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
214 # Bug 253127 252 # Bug 253127
215 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
216 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
217 fi 255 fi
218 256
219 # Bug 261632 257 # Bug 261632
220 if use ppc64; then 258 if use ppc64; then
221 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
222 append-flags -mminimal-toc 260 append-flags -mminimal-toc
223 fi 261 fi
224 262
263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
264 sed -e "/^SYSTEM_VARIABLES=/i \
265 CC='$(tc-getCC)'\n\
266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n\
270 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
272 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
273 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
274 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
275 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 if ! version_is_at_least 4.8; then
287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
289 fi
290
225 # Bug 172219 291 # Bug 172219
292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293
294 if [[ ${CHOST} == *-darwin* ]]; then
295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
226 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
229 -e "s:X11R6/::" \ 311 -e "s:-arch\s\w*::g" \
230 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
231 314
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 316 # fix arch handling (automagically duplicates our -arch arg and breaks
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 317 # pch). Additionally disable Xarch support.
235 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
322 sed \
323 -e "s:-arch i386::" \
324 -e "s:-arch ppc::" \
325 -e "s:-arch x86_64::" \
326 -e "s:-arch ppc64::" \
327 -e "s:-arch \$i::" \
328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
330 -e "s:-Xarch_x86_64::g" \
331 -e "s:-Xarch_ppc64::g" \
332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
236 334
237 base_src_prepare 335 # On Snow Leopard don't fall back to 10.5 deployment target.
336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
341 fi
342 fi
343
344 # this one is needed for all systems with a separate -liconv, apart from
345 # Darwin, for which the sources already cater for -liconv
346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
348 -i config.tests/unix/iconv/iconv.pro \
349 || die "sed iconv.pro failed"
350 fi
351
352 # we need some patches for Solaris
353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
355 # use GCC over SunStudio
356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
357 # do not flirt with non-Prefix stuff, we're quite possessive
358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
360
361 # apply patches
362 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
363 epatch_user
238} 364}
239 365
240# @FUNCTION: qt4-build_src_configure 366# @FUNCTION: qt4-build_src_configure
241# @DESCRIPTION: 367# @DESCRIPTION:
242# Default configure phase 368# Default configure phase
243qt4-build_src_configure() { 369qt4-build_src_configure() {
244 setqtenv 370 setqtenv
245 myconf="$(standard_configure_options) ${myconf}"
246 371
247 echo ./configure ${myconf}
248 ./configure ${myconf} || die "./configure failed"
249 myconf=""
250}
251
252# @FUNCTION: qt4-build_src_compile
253# @DESCRIPTION: Actual compile phase
254qt4-build_src_compile() {
255 setqtenv
256 # Be backwards compatible for now
257 if [[ $EAPI != 2 ]]; then
258 qt4-build_src_configure
259 fi
260
261 build_directories "${QT4_TARGET_DIRECTORIES}"
262}
263
264# @FUNCTION: qt4-build_src_install
265# @DESCRIPTION:
266# Perform the actual installation including some library fixes.
267qt4-build_src_install() {
268 setqtenv
269 install_directories "${QT4_TARGET_DIRECTORIES}"
270 install_qconfigs
271 fix_library_files
272}
273
274# @FUNCTION: setqtenv
275setqtenv() {
276 # Set up installation directories
277 QTBASEDIR=/usr/$(get_libdir)/qt4
278 QTPREFIXDIR=/usr
279 QTBINDIR=/usr/bin
280 QTLIBDIR=/usr/$(get_libdir)/qt4
281 QMAKE_LIBDIR_QT=${QTLIBDIR}
282 QTPCDIR=/usr/$(get_libdir)/pkgconfig
283 QTDATADIR=/usr/share/qt4
284 QTDOCDIR=/usr/share/doc/qt-${PV}
285 QTHEADERDIR=/usr/include/qt4
286 QTPLUGINDIR=${QTLIBDIR}/plugins
287 QTSYSCONFDIR=/etc/qt4
288 QTTRANSDIR=${QTDATADIR}/translations
289 QTEXAMPLESDIR=${QTDATADIR}/examples
290 QTDEMOSDIR=${QTDATADIR}/demos
291 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4
292 PLATFORM=$(qt_mkspecs_dir)
293
294 unset QMAKESPEC
295}
296
297# @FUNCTION: standard_configure_options
298# @DESCRIPTION:
299# Sets up some standard configure options, like libdir (if necessary), whether
300# debug info is wanted or not.
301standard_configure_options() {
302 local myconf="" 372 local conf="
303 373 -prefix ${QTPREFIXDIR}
304 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 374 -bindir ${QTBINDIR}
305 375 -libdir ${QTLIBDIR}
306 # Disable visibility explicitly if gcc version isn't 4 376 -docdir ${QTDOCDIR}
307 if [[ "$(gcc-major-version)" -lt "4" ]]; then 377 -headerdir ${QTHEADERDIR}
308 myconf="${myconf} -no-reduce-exports" 378 -plugindir ${QTPLUGINDIR}
309 fi 379 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
310 380 -datadir ${QTDATADIR}
311 # precompiled headers doesn't work on hardened, where the flag is masked. 381 -translationdir ${QTTRANSDIR}
312 if use pch; then 382 -sysconfdir ${QTSYSCONFDIR}
313 myconf="${myconf} -pch" 383 -examplesdir ${QTEXAMPLESDIR}
314 else 384 -demosdir ${QTDEMOSDIR}
315 myconf="${myconf} -no-pch" 385 -opensource -confirm-license
316 fi 386 -shared -fast -largefile -stl -verbose
317 387 -nomake examples -nomake demos"
318 if use debug; then
319 myconf="${myconf} -debug -no-separate-debug-info"
320 else
321 myconf="${myconf} -release -no-separate-debug-info"
322 fi
323 388
324 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 389 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
325 # $(tc-arch). Therefore we convert it to supported values. 390 # $(tc-arch). Therefore we convert it to supported values.
326 case "$(tc-arch)" in 391 case "$(tc-arch)" in
327 amd64) myconf="${myconf} -arch x86_64" ;; 392 amd64|x64-*) conf+=" -arch x86_64" ;;
393 ppc-macos) conf+=" -arch ppc" ;;
328 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 394 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
395 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
396 x86-macos) conf+=" -arch x86" ;;
329 x86|x86-*) myconf="${myconf} -arch i386" ;; 397 x86|x86-*) conf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 398 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
331 hppa|sh) myconf="${myconf} -arch generic" ;; 399 hppa|sh) conf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 400 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac 401 esac
334 402
335 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 403 conf+=" -platform $(qt_mkspecs_dir)"
336 local exceptions= 404
337 case "${PV}" in 405 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
338 4.6.*) 406
339 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then 407 # debug/release
340 exceptions="-no-exceptions" 408 if use debug; then
409 conf+=" -debug"
410 else
411 conf+=" -release"
412 fi
413 conf+=" -no-separate-debug-info"
414
415 # exceptions USE flag
416 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
417
418 # disable rpath on Qt >= 4.8 (bug 380415)
419 # but leave it enabled on prefix (bug 417169)
420 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
421
422 # precompiled headers don't work on hardened, where the flag is masked
423 conf+=" $(qt_use pch)"
424
425 # -reduce-relocations
426 # This flag seems to introduce major breakage to applications,
427 # mostly to be seen as a core dump with the message "QPixmap: Must
428 # construct a QApplication before a QPaintDevice" on Solaris.
429 # -- Daniel Vergien
430 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
431
432 # this one is needed for all systems with a separate -liconv, apart from
433 # Darwin, for which the sources already cater for -liconv
434 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
435 conf+=" -liconv"
436 fi
437
438 if use_if_iuse glib; then
439 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
440 # avoid the -pthread argument
441 conf+=" ${glibflags//-pthread}"
442 unset glibflags
443 fi
444
445 if use_if_iuse qpa; then
446 echo
447 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
448 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
449 ewarn "disable it before reporting any bugs related to this useflag."
450 echo
451 conf+=" -qpa"
452 fi
453
454 if use aqua; then
455 # On (snow) leopard use the new (frameworked) cocoa code.
456 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
457 conf+=" -cocoa -framework"
458 # We need the source's headers, not the installed ones.
459 conf+=" -I${S}/include"
460 # Add hint for the framework location.
461 conf+=" -F${QTLIBDIR}"
462
463 # We are crazy and build cocoa + qt3support :-)
464 if use qt3support; then
465 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
466 -i configure || die
341 fi 467 fi
342 ;; 468 else
343 *) 469 conf+=" -no-framework"
344 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 470 fi
345 ;; 471 else
346 esac 472 # freetype2 include dir is non-standard, thus pass it to configure
473 conf+=" $(pkg-config --cflags-only-I freetype2)"
474 fi
347 475
348 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
349 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
350 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
351 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
352 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
353 -demosdir ${QTDEMOSDIR} -silent -fast
354 ${exceptions}
355 -reduce-relocations -nomake examples -nomake demos"
356
357 # Make eclass >= 4.5.x ready
358 case "${MY_PV}" in
359 4.5.* | 4.6.* )
360 myconf="${myconf} -opensource"
361 ;;
362 esac
363
364 echo "${myconf}" 476 conf+=" ${myconf}"
477 myconf=
478
479 echo ./configure ${conf}
480 ./configure ${conf} || die "./configure failed"
481
482 prepare_directories ${QT4_TARGET_DIRECTORIES}
365} 483}
484
485# @FUNCTION: qt4-build_src_compile
486# @DESCRIPTION:
487# Actual compile phase
488qt4-build_src_compile() {
489 setqtenv
490
491 build_directories ${QT4_TARGET_DIRECTORIES}
492}
493
494# @FUNCTION: qt4-build_src_test
495# @DESCRIPTION:
496# Runs tests only in target directories.
497qt4-build_src_test() {
498 # QtMultimedia does not have any test suite (bug #332299)
499 [[ ${PN} == qt-multimedia ]] && return
500
501 for dir in ${QT4_TARGET_DIRECTORIES}; do
502 emake -j1 check -C ${dir}
503 done
504}
505
506# @FUNCTION: fix_includes
507# @DESCRIPTION:
508# For MacOS X we need to add some symlinks when frameworks are
509# being used, to avoid complications with some more or less stupid packages.
510fix_includes() {
511 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
512 local frw dest f h rdir
513 # Some packages tend to include <Qt/...>
514 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
515
516 # Fake normal headers when frameworks are installed... eases life later
517 # on, make sure we use relative links though, as some ebuilds assume
518 # these dirs exist in src_install to add additional files
519 f=${QTHEADERDIR}
520 h=${QTLIBDIR}
521 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
522 f=${f#*/}
523 h=${h#*/}
524 done
525 rdir=${h}
526 f="../"
527 while [[ ${h} == */* ]] ; do
528 f="${f}../"
529 h=${h#*/}
530 done
531 rdir="${f}${rdir}"
532
533 for frw in "${D}${QTLIBDIR}"/*.framework; do
534 [[ -e "${frw}"/Headers ]] || continue
535 f=$(basename ${frw})
536 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
537 dosym "${rdir}"/${f}/Headers "${dest}"
538
539 # Link normal headers as well.
540 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
541 h=$(basename ${hdr})
542 dosym "../${rdir}"/${f}/Headers/${h} \
543 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
544 done
545 done
546 fi
547}
548
549# @FUNCTION: qt4-build_src_install
550# @DESCRIPTION:
551# Perform the actual installation including some library fixes.
552qt4-build_src_install() {
553 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
554 setqtenv
555
556 install_directories ${QT4_TARGET_DIRECTORIES}
557 install_qconfigs
558 fix_library_files
559 fix_includes
560
561 # remove .la files since we are building only shared Qt libraries
562 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
563}
564
565# @FUNCTION: setqtenv
566# @INTERNAL
567setqtenv() {
568 # Set up installation directories
569 QTPREFIXDIR=${EPREFIX}/usr
570 QTBINDIR=${EPREFIX}/usr/bin
571 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
572 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
573 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
574 QTHEADERDIR=${EPREFIX}/usr/include/qt4
575 QTPLUGINDIR=${QTLIBDIR}/plugins
576 QTIMPORTDIR=${QTLIBDIR}/imports
577 QTDATADIR=${EPREFIX}/usr/share/qt4
578 QTTRANSDIR=${QTDATADIR}/translations
579 QTSYSCONFDIR=${EPREFIX}/etc/qt4
580 QTEXAMPLESDIR=${QTDATADIR}/examples
581 QTDEMOSDIR=${QTDATADIR}/demos
582 QMAKE_LIBDIR_QT=${QTLIBDIR}
583 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
584
585 PLATFORM=$(qt_mkspecs_dir)
586 unset QMAKESPEC
587
588 export XDG_CONFIG_HOME="${T}"
589}
590
591# @FUNCTION: prepare_directories
592# @USAGE: < directories >
593# @INTERNAL
594# @DESCRIPTION:
595# Generates Makefiles for the given list of directories.
596prepare_directories() {
597 for x in "$@"; do
598 pushd "${S}"/${x} >/dev/null || die
599 einfo "Running qmake in: ${x}"
600 # avoid running over the maximum argument number, bug #299810
601 {
602 echo "${S}"/mkspecs/common/*.conf
603 find "${S}" -name '*.pr[io]'
604 } | xargs sed -i \
605 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
606 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
607 || die
608 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
609 popd >/dev/null || die
610 done
611}
612
366 613
367# @FUNCTION: build_directories 614# @FUNCTION: build_directories
368# @USAGE: < directories > 615# @USAGE: < directories >
616# @INTERNAL
369# @DESCRIPTION: 617# @DESCRIPTION:
370# Compiles the code in $QT4_TARGET_DIRECTORIES 618# Compiles the code in the given list of directories.
371build_directories() { 619build_directories() {
372 local dirs="$@"
373 for x in ${dirs}; do 620 for x in "$@"; do
374 cd "${S}"/${x} 621 pushd "${S}"/${x} >/dev/null || die
375 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 622 emake CC="$(tc-getCC)" \
376 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 623 CXX="$(tc-getCXX)" \
377 emake CC="@echo compiling \$< && $(tc-getCC)" \
378 CXX="@echo compiling \$< && $(tc-getCXX)" \
379 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 624 LINK="$(tc-getCXX)" || die "emake failed"
625 popd >/dev/null || die
380 done 626 done
381} 627}
382 628
383# @FUNCTION: install_directories 629# @FUNCTION: install_directories
384# @USAGE: < directories > 630# @USAGE: < directories >
631# @INTERNAL
385# @DESCRIPTION: 632# @DESCRIPTION:
386# run emake install in the given directories, which are separated by spaces 633# Runs emake install in the given directories, which are separated by spaces.
387install_directories() { 634install_directories() {
388 local dirs="$@"
389 for x in ${dirs}; do 635 for x in "$@"; do
390 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 636 pushd "${S}"/${x} >/dev/null || die
391 emake INSTALL_ROOT="${D}" install || die "emake install failed" 637 emake INSTALL_ROOT="${D}" install || die "emake install failed"
392 popd >/dev/null || die "Can't popd from ${S}/${x}" 638 popd >/dev/null || die
393 done 639 done
394} 640}
395 641
396# @ECLASS-VARIABLE: QCONFIG_ADD 642# @ECLASS-VARIABLE: QCONFIG_ADD
397# @DESCRIPTION: 643# @DESCRIPTION:
398# List options that need to be added to QT_CONFIG in qconfig.pri 644# List options that need to be added to QT_CONFIG in qconfig.pri
399QCONFIG_ADD="${QCONFIG_ADD:-}" 645: ${QCONFIG_ADD:=}
400 646
401# @ECLASS-VARIABLE: QCONFIG_REMOVE 647# @ECLASS-VARIABLE: QCONFIG_REMOVE
402# @DESCRIPTION: 648# @DESCRIPTION:
403# List options that need to be removed from QT_CONFIG in qconfig.pri 649# List options that need to be removed from QT_CONFIG in qconfig.pri
404QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 650: ${QCONFIG_REMOVE:=}
405 651
406# @ECLASS-VARIABLE: QCONFIG_DEFINE 652# @ECLASS-VARIABLE: QCONFIG_DEFINE
407# @DESCRIPTION: 653# @DESCRIPTION:
408# List variables that should be defined at the top of QtCore/qconfig.h 654# List variables that should be defined at the top of QtCore/qconfig.h
409QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 655: ${QCONFIG_DEFINE:=}
410 656
411# @FUNCTION: install_qconfigs 657# @FUNCTION: install_qconfigs
658# @INTERNAL
659# @DESCRIPTION:
412# @DESCRIPTION: Install gentoo-specific mkspecs configurations 660# Install gentoo-specific mkspecs configurations.
413install_qconfigs() { 661install_qconfigs() {
414 local x 662 local x
415 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 663 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
416 for x in QCONFIG_ADD QCONFIG_REMOVE; do 664 for x in QCONFIG_ADD QCONFIG_REMOVE; do
417 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 665 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
418 done 666 done
419 insinto ${QTDATADIR}/mkspecs/gentoo 667 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
420 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 668 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
421 fi 669 fi
422 670
423 if [[ -n ${QCONFIG_DEFINE} ]]; then 671 if [[ -n ${QCONFIG_DEFINE} ]]; then
424 for x in ${QCONFIG_DEFINE}; do 672 for x in ${QCONFIG_DEFINE}; do
425 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 673 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
426 done 674 done
427 insinto ${QTHEADERDIR}/Gentoo 675 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
428 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 676 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
429 fi 677 fi
430} 678}
431 679
432# @FUNCTION: generate_qconfigs 680# @FUNCTION: generate_qconfigs
433# @DESCRIPTION: Generates gentoo-specific configurations 681# @INTERNAL
682# @DESCRIPTION:
683# Generates gentoo-specific qconfig.{h,pri}.
434generate_qconfigs() { 684generate_qconfigs() {
435 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 685 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
436 local x qconfig_add qconfig_remove qconfig_new 686 local x qconfig_add qconfig_remove qconfig_new
437 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 687 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
438 [[ -f ${x} ]] || continue 688 [[ -f ${x} ]] || continue
439 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 689 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
440 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 690 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
441 done 691 done
442 692
443 # these error checks do not use die because dying in pkg_post{inst,rm} 693 # these error checks do not use die because dying in pkg_post{inst,rm}
444 # just makes things worse. 694 # just makes things worse.
445 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 695 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
452 702
453 # generate list of QT_CONFIG entries from the existing list 703 # generate list of QT_CONFIG entries from the existing list
454 # including qconfig_add and excluding qconfig_remove 704 # including qconfig_add and excluding qconfig_remove
455 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 705 for x in $(sed -n 's/^QT_CONFIG +=//p' \
456 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 706 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
457 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 707 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
458 done 708 done
459 709
460 # replace the existing QT_CONFIG list with qconfig_new 710 # replace the existing QT_CONFIG list with qconfig_new
461 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 711 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
462 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 712 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
486 fi 736 fi
487 fi 737 fi
488} 738}
489 739
490# @FUNCTION: qt4-build_pkg_postrm 740# @FUNCTION: qt4-build_pkg_postrm
741# @DESCRIPTION:
491# @DESCRIPTION: Generate configurations when the package is completely removed 742# Regenerate configuration when the package is completely removed.
492qt4-build_pkg_postrm() { 743qt4-build_pkg_postrm() {
493 generate_qconfigs 744 generate_qconfigs
494} 745}
495 746
496# @FUNCTION: qt4-build_pkg_postinst 747# @FUNCTION: qt4-build_pkg_postinst
748# @DESCRIPTION:
497# @DESCRIPTION: Generate configuration, plus throws a message about possible 749# Regenerate configuration, plus throw a message about possible
498# breakages and proposed solutions. 750# breakages and proposed solutions.
499qt4-build_pkg_postinst() { 751qt4-build_pkg_postinst() {
500 generate_qconfigs 752 generate_qconfigs
501
502 if [[ "${PN}" == "qt-core" ]]; then
503 echo
504 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
505 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
506 ewarn "should recompile the packages providing these plugins. Also, make sure you"
507 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
508 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
509 ewarn
510 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
511 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
512 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
513 ewarn "configuration."
514 ewarn
515 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
516 echo
517 fi
518} 753}
519 754
520# @FUNCTION: skip_qmake_build_patch 755# @FUNCTION: skip_qmake_build
756# @INTERNAL
521# @DESCRIPTION: 757# @DESCRIPTION:
522# Don't need to build qmake, as it's already installed from qt-core 758# Patches configure to skip qmake compilation, as it's already installed by qt-core.
523skip_qmake_build_patch() { 759skip_qmake_build() {
524 # Don't need to build qmake, as it's already installed from qt-core
525 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 760 sed -i -e "s:if true:if false:g" "${S}"/configure || die
526} 761}
527 762
528# @FUNCTION: skip_project_generation_patch 763# @FUNCTION: skip_project_generation
764# @INTERNAL
529# @DESCRIPTION: 765# @DESCRIPTION:
530# Exit the script early by throwing in an exit before all of the .pro files are scanned 766# Exit the script early by throwing in an exit before all of the .pro files are scanned.
531skip_project_generation_patch() { 767skip_project_generation() {
532 # Exit the script early by throwing in an exit before all of the .pro files are scanned
533 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 768 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
534 -i "${S}"/configure || die "Sed failed"
535} 769}
536 770
537# @FUNCTION: symlink_binaries_to_buildtree 771# @FUNCTION: symlink_binaries_to_buildtree
772# @INTERNAL
538# @DESCRIPTION: 773# @DESCRIPTION:
539# Symlink generated binaries to buildtree so they can be used during compilation 774# Symlinks generated binaries to buildtree, so they can be used during compilation time.
540# time
541symlink_binaries_to_buildtree() { 775symlink_binaries_to_buildtree() {
542 for bin in qmake moc uic rcc; do 776 for bin in qmake moc uic rcc; do
543 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 777 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
544 done 778 done
545} 779}
546 780
547# @FUNCTION: fix_library_files 781# @FUNCTION: fix_library_files
782# @INTERNAL
548# @DESCRIPTION: 783# @DESCRIPTION:
549# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 784# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
550# moves the *.pc-files into the pkgconfig directory 785# moves the *.pc files into the pkgconfig directory.
551fix_library_files() { 786fix_library_files() {
787 local libfile
552 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 788 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
553 if [[ -e ${libfile} ]]; then 789 if [[ -e ${libfile} ]]; then
554 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 790 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
555 fi 791 fi
556 done 792 done
557 793
558 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 794 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
559 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 795 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
560 if [[ -e ${libfile} ]]; then 796 if [[ -e ${libfile} ]]; then
561 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 797 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
562 798
563 # Move .pc files into the pkgconfig directory 799 # Move .pc files into the pkgconfig directory
564 dodir ${QTPCDIR} 800 dodir ${QTPCDIR#${EPREFIX}}
565 mv ${libfile} "${D}"/${QTPCDIR}/ \ 801 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
566 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
567 fi 802 fi
568 done 803 done
569 804
570 # Don't install an empty directory 805 # Don't install an empty directory
571 rmdir "${D}"/${QTLIBDIR}/pkgconfig 806 rmdir "${D}"/${QTLIBDIR}/pkgconfig
572} 807}
573 808
574# @FUNCTION: qt_use 809# @FUNCTION: qt_use
575# @USAGE: < flag > [ feature ] [ enableval ] 810# @USAGE: < flag > [ feature ] [ enableval ]
576# @DESCRIPTION: 811# @DESCRIPTION:
577# This will echo "${enableval}-${feature}" if <flag> is enabled, or 812# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
578# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 813# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
579# will be used for that. If [enableval] is not specified, it omits the 814# will be used for that. If [enableval] is not specified, it omits the
580# assignment-part 815# "-${enableval}" part.
581qt_use() { 816qt_use() {
582 local flag="${1}" 817 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
583 local feature="${1}"
584 local enableval=
585
586 [[ -n ${2} ]] && feature=${2}
587 [[ -n ${3} ]] && enableval="-${3}"
588
589 if use ${flag}; then
590 echo "${enableval}-${feature}"
591 else
592 echo "-no-${feature}"
593 fi
594}
595
596# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
597# @DESCRIPTION:
598# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
599# (eutils.eclass), line per line.
600#
601# Example:
602# @CODE
603# pkg_setup() {
604# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
605# ~x11-libs/qt-gui-${PV} qt3support"
606# qt4-build_check_use
607# }
608# @CODE
609
610# Run built_with_use on each flag and print appropriate error messages if any
611# flags are missing
612
613_qt_built_with_use() {
614 local missing opt pkg flag flags
615
616 if [[ ${1} = "--missing" ]]; then
617 missing="${1} ${2}" && shift 2
618 fi
619 if [[ ${1:0:1} = "-" ]]; then
620 opt=${1} && shift
621 fi
622
623 pkg=${1} && shift
624
625 for flag in "${@}"; do
626 flags="${flags} ${flag}"
627 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
628 flags="${flags}*"
629 else
630 [[ ${opt} = "-o" ]] && return 0
631 fi
632 done
633 if [[ "${flags# }" = "${@}" ]]; then
634 return 0
635 fi
636 if [[ ${opt} = "-o" ]]; then
637 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
638 else
639 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
640 fi
641 return 1
642}
643
644# @FUNCTION: qt4-build_check_use
645# @DESCRIPTION:
646# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
647# USE flags listed.
648#
649# If any of the required USE flags are missing, an eerror will be printed for
650# each package with missing USE flags.
651qt4-build_check_use() {
652 local line missing
653 while read line; do
654 [[ -z ${line} ]] && continue
655 if ! _qt_built_with_use ${line}; then
656 missing=true
657 fi
658 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
659 if [[ -n ${missing} ]]; then
660 echo
661 eerror "Flags marked with an * are missing."
662 die "Missing USE flags found"
663 fi
664} 818}
665 819
666# @FUNCTION: qt_mkspecs_dir 820# @FUNCTION: qt_mkspecs_dir
667# @RETURN: the specs-directory w/o path 821# @RETURN: the specs-directory w/o path
668# @DESCRIPTION: 822# @DESCRIPTION:
669# Allows us to define which mkspecs dir we want to use. 823# Allows us to define which mkspecs dir we want to use.
670qt_mkspecs_dir() { 824qt_mkspecs_dir() {
671 # Allows us to define which mkspecs dir we want to use.
672 local spec 825 local spec=
673 826
674 case ${CHOST} in 827 case "${CHOST}" in
675 *-freebsd*|*-dragonfly*) 828 *-freebsd*|*-dragonfly*)
676 spec="freebsd" ;; 829 spec=freebsd ;;
677 *-openbsd*) 830 *-openbsd*)
678 spec="openbsd" ;; 831 spec=openbsd ;;
679 *-netbsd*) 832 *-netbsd*)
680 spec="netbsd" ;; 833 spec=netbsd ;;
681 *-darwin*) 834 *-darwin*)
835 if use aqua; then
836 # mac with carbon/cocoa
837 spec=macx
838 else
839 # darwin/mac with x11
682 spec="darwin" ;; 840 spec=darwin
841 fi
842 ;;
843 *-solaris*)
844 spec=solaris ;;
683 *-linux-*|*-linux) 845 *-linux-*|*-linux)
684 spec="linux" ;; 846 spec=linux ;;
685 *) 847 *)
686 die "Unknown CHOST, no platform choosen." 848 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
687 esac 849 esac
688 850
689 CXX=$(tc-getCXX) 851 case "$(tc-getCXX)" in
690 if [[ ${CXX/g++/} != ${CXX} ]]; then 852 *g++*)
691 spec="${spec}-g++" 853 spec+=-g++ ;;
692 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 854 *icpc*)
693 spec="${spec}-icc" 855 spec+=-icc ;;
694 else 856 *)
695 die "Unknown compiler ${CXX}." 857 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
696 fi 858 esac
697 if [[ -n "${LIBDIR/lib}" ]]; then 859
698 spec="${spec}-${LIBDIR/lib}" 860 # Add -64 for 64bit profiles
861 if use x64-freebsd ||
862 use amd64-linux ||
863 use x64-macos ||
864 use x64-solaris ||
865 use sparc64-solaris
866 then
867 spec+=-64
699 fi 868 fi
700 869
701 echo "${spec}" 870 echo "${spec}"
702} 871}
703 872
704case ${EAPI:-0} in 873# @FUNCTION: qt_nolibx11
705 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 874# @INTERNAL
875# @DESCRIPTION:
876# Ignore X11 tests for packages that don't need X libraries installed.
877qt_nolibx11() {
878 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
879 die "x11 check sed failed"
880}
881
706 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 882EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
707esac

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.135

  ViewVC Help
Powered by ViewVC 1.1.20